; Eastweed - EAsy STatic WEb EDitor
; Copyright (C) 2006, 2007, 2008, 2009 Gianni Ciolli <gc@inatna.it> 
; file module-deploy.scm, version 0.7beta, date 2009-02-26
;
; Based on existing code (C) 2001, 2004 by Marco Maggesi
; <maggesi@math.unifi.it> and Gianni Ciolli <ciolli@math.unifi.it>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

;; module-deploy.scm - this is the Eastweed deploy module.

;;; TODO: create various scripts to simplify operations

(eastweed 'assert 'data-prefix)

;; create a template data directory
(let ((d (eastweed 'get 'data-prefix)))
  (cond
   ((and (not (directory-exists? d))
	 (not (file-exists? d))
	 (not (link-exists? d)))
    ;; create data directory
    (make-directory d)
    ;; fill it
    (for-each
     (lambda (s)
       (copy-file (string-append
		   eastweed-installation "/templates/" s ".txt")
		  (string-append d s ".txt")))
     '("index.en"))
    ;; create timestamp
    (let ((s (file-or-directory-modify-seconds d))
	  (f (eastweed 'get 'update-timestamp-file)))
      (with-output-to-file f newline)
      (file-or-directory-modify-seconds f (- s 1))))
   ;;
   ((directory-exists? d)
    (logmsg "keeping existing directory " d))
   (else
    (errmsg "cannot create directory " d))))

;; create a web-pages directory
(let ((d (eastweed 'get 'web-pages-prefix)))
  (cond
   ((and (not (directory-exists? d))
	 (not (file-exists? d))
	 (not (link-exists? d)))
    ;; create data directory
    (make-directory d))
   ;;
   ((directory-exists? d)
    (logmsg "keeping existing directory " d))
   (else
    (errmsg "cannot create directory " d))))

;; creates custom executable scripts
(define (create-executable f a)
  (with-output-to-file
      (string-append f ".sh")
    (lambda ()
      (disp "#!/bin/sh")
      (disp "mzscheme -f " 
	    eastweed-installation
	    "main.scm -e \"(eastweed '"
	    a
	    ")\""))
    #:exists 'truncate))

(create-executable "update" "update")
(create-executable "update-all" "update-all")
