; Eastweed - EAsy STatic WEb EDitor
; Copyright (C) 2006, 2007, 2008, 2009 Gianni Ciolli <gc@inatna.it> 
; file module-schtml.scm, version 0.7beta, date 2009-02-26
;
; Based on existing code (C) 2001, 2004 by Marco Maggesi
; <maggesi@math.unifi.it> and Gianni Ciolli <ciolli@math.unifi.it>
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

;; module-schtml.scm - this is the Eastweed schtml module.

;; version >= 201
(require (lib "xml.ss" "xml"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define (read/list inport)
  (let ((val (read inport)))
    (if (eof-object? val)
	'()
	(cons val (read/list inport)))))

(define (apply-page-style page-src page-style)
  (page-style page-src))

(define (schtml->html schtml out-file)
  (call-with-output-file out-file
    (lambda (outport)
      (display (eastweed 'get 'doctype-string) outport)
      (parameterize
       ((empty-tag-shorthand html-empty-tags))
       (write-xml/content (xexpr->xml schtml)
			  outport)))
    #:exists 'truncate))

(define (build-page src-file out-file)
  (call-with-input-file src-file
    (lambda (inport)
      (call-with-output-file out-file
	(lambda (outport)
	  (display (eastweed 'get 'doctype-string)
		   outport)
	  (let ((l (eval (list 'quasiquote (read/list inport)))))
	    (parameterize
	     ((empty-tag-shorthand html-empty-tags))
	     (write-xml/content
	      (xexpr->xml
	       (apply-page-style (cdr l) (car l)))
	      outport))))
	#:exists 'replace))))

(define (main-build argv)
  (let ((src (vector-ref argv 0))
	(dst (vector-ref argv 1)))
    (let ((src-code (basename-prepend "z-" src)))
      (when (x-file-exists? src-code)
	    (load src-code))
      (begin
	(build-page src dst)))))
